SystemOrganization addCategory: #'Pier-Wysiwyg'!

WAComponent subclass: #PRWysiwygEditor
	instanceVariableNames: 'pierWikiText tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditor class methodsFor: 'initialize-release' stamp: 'NickAger 7/7/2011 17:20'!
initialize
	super initialize.
	self register! !

!PRWysiwygEditor class methodsFor: 'initialize-release' stamp: 'NickAger 7/7/2011 17:19'!
register
	(WAAdmin register: self asApplicationAt: 'wysiwygtest')
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQRedmondTheme;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator.! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 12:13'!
editorJs: textAreaId
	"see: 
		* http://developer.yahoo.com/yui/examples/editor/toolbar_editor.html
		* http://developer.yahoo.com/yui/docs/editor.js.html
		* http://developer.yahoo.com/yui/editor/
		* http://developer.yahoo.com/yui/examples/editor/cal_editor.html
		* http://developer.yahoo.com/yui/examples/editor/flickr_editor.html"
	^ 
'var myEditor = new YAHOO.widget.Editor("', textAreaId, '", {
	height: "300px",
	width: "600px",
	autoHeight: true,
	toolbar: {
		focusAtStart: true,
		buttons: [ 
	    		{ group: "parastyle", label: "",
				buttons: [
					{ type: "select", label: "Normal", value: "heading", disabled: true,
						menu: [
							{ text: "Normal", value: "none", checked: true },
							{ text: "Header 1", value: "h1" },
							{ text: "Header 2", value: "h2" },
							{ text: "Header 3", value: "h3" },
							{ text: "Header 4", value: "h4" },
							{ text: "Header 5", value: "h5" },
							{ text: "Header 6", value: "h6" }
						]
					}
				]
			},
			{ type: "separator" },
			{ group: "indentlist", label: "",
			    buttons: [
			        { type: "push", label: "Create an Unordered List", value: "insertunorderedlist" },
			        { type: "push", label: "Create an Ordered List", value: "insertorderedlist" }
			    ]
			},
			{ type: "separator" },
			{ group: "textstyle" , label: "",
				buttons: [
            			{ type: "push", label: "Bold CTRL + SHIFT + B",  value: "bold" }, 
					{ type: "push", label: "Italic CTRL + SHIFT + I", value: "italic" }, 
					{ type: "push", label: "Underline CTRL + SHIFT + U", value: "underline" },
					{ type: "push", label: "Code", value: "code" },
					{ type: "push", label: "Strikeout", value: "strike" },
					{ type: "separator" },
					{ type: "push", label: "Subscript", value: "subscript", disabled: true },
					{ type: "push", label: "Superscript", value: "superscript", disabled: true },
				 ]
			 },
	    		{ type: "separator" },
			{ group: "insertitem", label: "",
			    buttons: [
				{ type: "push", label: "Horizontal Rule", value: "rule" },
			        { type: "push", label: "HTML Link CTRL + SHIFT + L", value: "createlink", disabled: true },
			        { type: "push", label: "Insert Image", value: "insertimage" }
			    ]
			}
		]
	}
} );

myEditor.cmd_code = function (o) {
	this.execCommand("inserthtml", "<code>" + this._getSelection() + "</code>");
}
myEditor.cmd_rule = function (o) {
	this.execCommand("inserthtml", "<hr>");
}
myEditor.cmd_strike = function (o) {
	this.execCommand("inserthtml", "<del>" + this._getSelection() + "</del>");
}

myEditor.render();
' withInternetLineEndings

"	
{ group: ''formatting'' , label: ''Formatting'',
  buttons: [
	{ type: ''separator'' },
	{ type: ''push'', label: ''Remove Formatting'', value: ''removeformat'', disabled: true },
	{ type: ''push'', label: ''Show/Hide Hidden Elements'', value: ''hiddenelements'' }
   ]
}
"
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 17:41'!
onSelectTabJSOn: html
	^ 
	((JSStream on: 'if (ui.index == 1) {') ,
	((html jQuery id: #hiddenWikiText) value: (JSStream on: 'parseHtmlToPierWikiSyntax(myEditor._getDoc().body)')),
	(html jQuery ajax serialize: (html jQuery id: #hiddenWikiText)),
	(JSStream on: '}	
if (ui.index == 2) {') ,
	((html jQuery id: #hiddenWikiText) value: (html jQuery id: #standardPierEditor)),
	(html jQuery ajax serialize: (html jQuery id: #hiddenWikiText)), 
	(JSStream on: '}')) asFunction: #('event' 'ui')! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/7/2011 15:15'!
pierWikiText
	^ pierWikiText ifNil: [ 
		pierWikiText := '!!A Wysiwyg editor for Pier

Currently the editor supports:
# ""Bold""
# ''''Italic''''
# __Underline__
# ==code==
# --strikeout--
# Headings
# line-breaks and paragraphs
# ordered and unordered lists.
# super^^script^^ and sub@@script@@
# horizontal line
_
The translator also supports the following, although there are no editor buttons to support it:
- definition list and definitions
- preformated.
Still to come support for images, external and internal links, named anchors and tables.
_
!!!!!! Notes
The editor needs to support all the Pier Wiki markup, so the Wysiwyg editor can be used interchangebly with the standard editor without fear of loosing any markup, that is it should be possible to use for editing Pier book content.

The tricky part of the implementation will be preserve embedded links, value links and verbatium html in Wysiwyg mode. The plan is:
- Implement a custom version of PRViewRenderer and override ==#visitVerbatim:==,   ==#visitInternalLink:==, ==#visitValueLink:== to ensure the content they return is surrounded by a identiable ==div== or ==span== eg ==div class="pierEmbeddedLink" title="+/link/path/here+" Embedded link contents here==
- Implement content listeners, within the Wysiwyg editor- that prevent the embedded contents from being edited.
- Implement custom dialogs for embedded links, value links and verbatium html in which the raw wiki syntax to be edited. 
- Ensure the JS parser interrepts the embedded links and strips the embedded content when converting back to wiki syntax. 
The standard Wysiwyg editor''s implementation of dialog and content sniffing for the images look as though they will be able to serve as a template.

!!!!!! Thoughts and questions
- It should be possible to switch between Wysiwyg and standard views (a tabbed interface?)
- Some features should only be enabled for certain groups. For example you don''t want untrusted users to be able to insert verbatium html or edit the content in the standard view. Question - how to enable this functionality without tying to a specific group. A configurable group, a custom permission? Is it acceptable to make the Wysiwyg editor dependant on Pier-Security? 
Perhaps we implement the following permissions:
- ==PRVerbatiumEditingPermission==
- ==PRWikiTextEditingPermission==
- ==PREmbeddedLinksPermission==

!!!!!!Useful links
- *http://developer.yahoo.com/yui/editor/*
- *http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf*
- *http://developer.yahoo.com/yui/examples/editor/toolbar_editor.html*
- *http://developer.yahoo.com/yui/docs/editor.js.html*
- *http://developer.yahoo.com/yui/editor/*
- *http://developer.yahoo.com/yui/examples/editor/cal_editor.html*
- *http://developer.yahoo.com/yui/examples/editor/flickr_editor.html*']! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/5/2011 13:36'!
pierWikiText: anObject
	pierWikiText := anObject! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 17:34'!
renderContentOn: html
	html form: [
		self renderSiteMapSelectOn: html.
		self renderTabsOn: html.
		self renderHiddenWikiTextOn: html ]
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 17:42'!
renderHiddenWikiTextOn: html
	html hiddenInput
		id: #hiddenWikiText;
		on: #pierWikiText of: self
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/5/2011 13:37'!
renderPierToHtmlOn: html
	"renders wiki text into html"
	| parsedStructure renderer |
		
	parsedStructure := PRDocumentParser parseStream: self pierWikiText readStream.
	renderer := PRViewRenderer new.
	renderer withinContentDo: [
		renderer start: parsedStructure in: self on: html ]! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 11:54'!
renderSiteMapSelectOn: html
	| kernel user viewableStructures |
	
	kernel := PRKernel instances anyOne.
	user :=  kernel userNamed: 'nick.ager@gmail.com' ifNone: [ kernel users add: ((PUUser named: 'nick.ager@gmail.com') password: 'password'; yourself) ].
	viewableStructures := kernel root enumerator with; all; select: [ :aStructure | aStructure securityDecoration hasPermission: (PUPermission on: PRViewCommand) for: user].
	
	html select
		list: (viewableStructures collect: [ :aStructure | aStructure absolutePath])! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 17:37'!
renderStandardPierEditorOn: html
	"the standard pier editor toolbar expects the textarea to be wrapped in a td - yuk"
	html table
		cellpadding: 0;
		cellspacing: 0;
		with: [
			html tableRow: [
				html tableData
					class: 'wiki';
					with: [
						html textArea
							id: #standardPierEditor;
							script: (JSStream on: 'EditorEnh($("#standardPierEditor")[0], { binding: true, toolbar: true})');
							with: self pierWikiText ] ] ]! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 17:27'!
renderTabsOn: html
	html div
		script: (html jQuery this tabs
			onSelect: (self onSelectTabJSOn: html));
		with: [
			html unorderedList: [
				self tabs associationsDo: [ :each |
					html listItem: [
						html anchor
							url: (html jQuery ajax html: each value; fullUrl);
							with: each key ] ] ] ]
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/7/2011 17:48'!
renderWysiwygEditorOn: html
	| textAreaId |
	
	html textArea
		id: (textAreaId := html nextId);
		with: [ self renderPierToHtmlOn: html ].
		
	html script: (self editorJs: textAreaId)
! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/7/2011 17:08'!
standardPierEditorUpdateRoot: anHtmlRoot
	PREditorScripts default updateRoot: anHtmlRoot.! !

!PRWysiwygEditor methodsFor: 'private' stamp: 'NickAger 7/7/2011 17:18'!
tabs
	^ tabs ifNil: [
		tabs := Dictionary new.
		tabs 
			at: 'Wysiwyg editor' put: [ :r | self renderWysiwygEditorOn: r ];
			at: 'Standard Pier Editor' put: [ :r | self renderStandardPierEditorOn: r ].
		tabs ]! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/7/2011 17:08'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	self wysiwygUpdateRoot: anHtmlRoot.
	self standardPierEditorUpdateRoot: anHtmlRoot! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/7/2011 17:12'!
wysiwygCustomisationUpdateRoot: anHtmlRoot
	anHtmlRoot bodyAttributes addClass: 'yui-skin-sam'.
	anHtmlRoot javascript url: PRWysiwygFileLibrary / #parseHtmlToPierWikiSyntaxJs.
	
	anHtmlRoot stylesheet add: '
.yui-toolbar-group {
	margin-top: 4px;
}
.yui-skin-sam .yui-toolbar-container .yui-toolbar-code span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -64px 0px;
	margin-left: 5px;
	margin-top: 2px;
}

.yui-skin-sam .yui-toolbar-container .yui-toolbar-rule span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -208px 0px;
	margin-left: 5px;
	margin-top: 2px;
}

.yui-skin-sam .yui-toolbar-container .yui-toolbar-strike span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -48px 0px;
	margin-left: 5px;
	margin-top: 2px;
}
'
	
! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/7/2011 17:12'!
wysiwygStandardConfigUpdateRoot: anHtmlRoot
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.9.0/build/assets/skins/sam/skin.css'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/yahoo-dom-event/yahoo-dom-event.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/element/element-min.js'.
	
	"Needed for Menus, Buttons and Overlays used in the Toolbar"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/container/container_core-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/menu/menu-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/button/button-min.js'.
	
	"Source file for Rich Text Editor"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/editor/editor-min.js'.	
! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/7/2011 17:13'!
wysiwygUpdateRoot: anHtmlRoot.
	"See YUI editor documentation: 
		* http://developer.yahoo.com/yui/editor/
		* http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf"

	self wysiwygStandardConfigUpdateRoot: anHtmlRoot.
	self wysiwygCustomisationUpdateRoot: anHtmlRoot.
! !

WAFileLibrary subclass: #PRWysiwygFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 7/7/2011 23:50'!
parseHtmlToPierWikiSyntaxJs
	^ 'var parseHtmlToPierWikiSyntax = function (startNode) {
	var wikiOutput = [];
	var newLine = "\n"
	
	var surroundingMarkup = function(markup) {
		return function(node) {
			wikiOutput.push(markup);
			walkTheDOM (node.firstChild);
			wikiOutput.push(markup)
		}
	}

	var startLineMarkup = function(markup) {
		return function(node) {
			// if not at the start of the document
			if (wikiOutput.length) {
				wikiOutput.push(newLine);
			}
			if (markup.length) {
				wikiOutput.push(markup);
			}
			walkTheDOM (node.firstChild);
			wikiOutput.push(newLine);
		}
	}
	
	var listWalk = function () {
		return function (node) {
			var startLength = wikiOutput.length;
			walkTheDOM (node.firstChild);
			var endLength = wikiOutput.length;
			
			// remove consecutive new lines. 
			var previousNewLineIndex = -1;
			for (var i = startLength - 1; i < endLength; ++i) {
				if (wikiOutput [i] == newLine) {
					// we have consecutive new lines.
					if (previousNewLineIndex == i - 1) {
						delete wikiOutput [i];
					}
				previousNewLineIndex = i;		
				}
			}
			
			// ensure we finish with a new line
			if (wikiOutput [wikiOutput.length - 1] && wikiOutput [wikiOutput.length - 1] !!= newLine) {
				wikiOutput.push(newLine);
			}
			
			// ensure there is only a single space between the list markup and the list contents
			for (var i = startLength - 1; i < endLength; ++i) {
				if ((wikiOutput [i] == "# " || wikiOutput [i] == "- ") && (i + 1 < wikiOutput.length)) {
					var listElement = wikiOutput [i + 1];
					var firstNonSpaceIndex = 0;
					while (firstNonSpaceIndex < listElement.length && listElement [firstNonSpaceIndex] == " ") {
						++ firstNonSpaceIndex  ;
					}
					wikiOutput [i + 1] = listElement.substring (firstNonSpaceIndex, listElement.length);
				}
			}		
		}
	}
	
	var listElement = function () {
		return function (node) {
			var parentNodeName = nodeName = node.parentNode.nodeName.toLowerCase();
			if (parentNodeName == ''ul'') {
				startLineMarkup(''- '')(node)
			}
			if (parentNodeName == ''ol'') {
				startLineMarkup(''# '')(node)
			}
		}
	}
	
	var tableMarkup = function () {
		return function () {}
	}
	
	var anchor = function(node) {
		return function(node) {
			if(node.getAttribute("href")) {
				var baseUrl = window.location.host;
				var anchorUrl = node.getAttribute("href");
				var url = (anchorUrl.indexOf(baseUrl) == 0) ? anchorUrl.substr(0, baseUrl.length) : anchorUrl;

				wikiOutput.push("*");
				walkTheDOM(node.firstChild);
				wikiOutput.push(">");
				wikiOutput.push(node.getAttribute("href"));
				wikiOutput.push("*");
			}
		}
	}
	
	var handleText = function(node) {
		var text = node.nodeValue;

		// if the string starts with a newLine strip it.
		if (text.length && text [0] == newLine) {
			text = text.substr(1, text.length - 1); 
		}		
		
		// if the string ends with a newLine strip it.
		if (text.length && text [text.length - 1] == newLine) {
			text = text.substr(0, text.length - 2); 
		}
		
		if (text.trim().length !!== 0) {
			wikiOutput.push(text);
		}
	}

	var elementToWikiMarkupMappingTable = {
		''b'': surroundingMarkup(''\"\"''),
		''strong'': surroundingMarkup(''\"\"''),
		''i'': surroundingMarkup("\''\''"),
		''em'': surroundingMarkup("\''\''"),
		''ins'': surroundingMarkup("__"),
		''u'': surroundingMarkup("__"),
		"del": surroundingMarkup("--"),
		''code'': surroundingMarkup("=="),
		''sub'': surroundingMarkup("@@"),
		''sup'': surroundingMarkup("^^"),
		''a'': anchor(),
		''h1'': startLineMarkup (''!!''),
		''h2'': startLineMarkup(''!!!!''), 
		''h3'': startLineMarkup(''!!!!!!''),
		''h4'': startLineMarkup(''!!!!!!!!''), 
		''h5'': startLineMarkup(''!!!!!!!!!!''), 
		''h6'': startLineMarkup(''!!!!!!!!!!!!''),
		''hr'': startLineMarkup(''_''),
		"br": startLineMarkup(''''),
		"p": startLineMarkup(''''),
		"ul": listWalk(),
		"ol": listWalk(),	
		''li'': listElement(),	
		''dl'': startLineMarkup('';''),
		''dd'': startLineMarkup('':''),
		''pre'': startLineMarkup(''=''),
		''hr'': startLineMarkup("_"),
		''table'': tableMarkup()
	}

    var nodeTypes = {
        ELEMENT_NODE: 1,
        ATTRIBUTE_NODE: 2,
        TEXT_NODE: 3,
        CDATA_SECTION_NODE: 4,
        ENTITY_REFERENCE_NODE: 5,
        ENTITY_NODE: 6,
        PROCESSING_INSTRUCTION_NODE: 7,
        COMMENT_NODE: 8,
        DOCUMENT_NODE: 9,
        DOCUMENT_TYPE_NODE: 10,
        DOCUMENT_FRAGMENT_NODE: 11,
        NOTATION_NODE: 12
    }
	
	// the recursive DOM walker
    var walkTheDOM = function (node) {
		if (node === null)
			return ;
			
		switch (node.nodeType) {
            case nodeTypes.ELEMENT_NODE:
			var nodeName = node.nodeName.toLowerCase();
			if (elementToWikiMarkupMappingTable.hasOwnProperty (nodeName)) {
				elementToWikiMarkupMappingTable [nodeName](node);
			}
			break;
                
            case nodeTypes.TEXT_NODE:
			handleText(node);
			break; 
                
            case nodeTypes.ATTRIBUTE_NODE:
            case nodeTypes.CDATA_SECTION_NODE:
            case nodeTypes.ENTITY_REFERENCE_NODE:
            case nodeTypes.ENTITY_NODE:
            case nodeTypes.PROCESSING_INSTRUCTION_NODE:
            case nodeTypes.COMMENT_NODE:
            case nodeTypes.DOCUMENT_NODE:
            case nodeTypes.DOCUMENT_TYPE_NODE:
            case nodeTypes.DOCUMENT_FRAGMENT_NODE:
            case nodeTypes.NOTATION_NODE:
                break;
			}

		walkTheDOM (node.nextSibling);
    }
	walkTheDOM (startNode.firstChild);
	
	return wikiOutput.join('''');
}' withInternetLineEndings! !
PRWysiwygEditor initialize!
